package net.minecraft.src;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL12;
import org.lwjgl.opengl.GL13;

import reifnsk.gui.*;

public class GuiPetRenameJP extends JGuiScreen implements ActionListener
{
    private EntityPlayer player;
    private EntityLiving owner;
    private EntityNameplate nameplate;
    private ItemStack consuming;
    private JGuiMCButton buttonO;
    private JGuiMCButton buttonC;
    private JGuiTextField input;
    private long updateCounter;
    private boolean isUpdateFrame;

    public GuiPetRenameJP(World world, EntityPlayer player, EntityLiving owner, ItemStack item)
    {
        this.player = player;
        this.owner = owner;
        this.consuming = item;
        this.nameplate = null;
        this.updateCounter = 0L;
        this.isUpdateFrame = false;
        Iterator var5 = world.loadedEntityList.iterator();

        System.out.println("Search exists nameplate...");
        while (var5.hasNext())
        {
            Object var6 = var5.next();

            if (var6 instanceof EntityNameplate)
            {
                EntityNameplate var7 = (EntityNameplate)var6;

                if (var7.entityOwner != null && owner.entityId == var7.entityOwner.entityId)
                {
                    this.nameplate = var7;
                    System.out.println("Nameplate found!");
                    break;
                }
            }
        }

        if (this.nameplate == null)
        {
            System.out.println("Create nameplate.");
            this.nameplate = EntityNameplate.CreateNameplate(world, owner);
            if (this.nameplate == null) {
                this.mc.displayGuiScreen((GuiScreen)null);
                return;
            }
            world.spawnEntityInWorld(this.nameplate);
        }
    }

    public void initGui()
    {
        buttonO = new JGuiMCButton("OK");
        buttonO.setBounds(this.width / 2 - 90, this.height - 60, 80, 20);
        buttonO.addActionListener(this);
        add(buttonO);
        buttonC = new JGuiMCButton("Cancel");
        buttonC.setBounds(this.width / 2 + 10, this.height - 60, 80, 20);
        buttonC.addActionListener(this);
        add(buttonC);
        input = new JGuiTextField(this.width / 2 - 89, this.height - 92, 178, 20);
        input.setBorder(new JEmptyBorder(2, 2, 2, 2));
        input.setLimit(100);
        input.setText(this.nameplate.petName);
        add(input);
        input.requestFocus();
    }

    public void actionPerformed(ActionEvent actionevent)
    {
        if (actionevent.getSource() == buttonO)
        {
            String var2 = this.input.getText();

            if (var2 != "" && this.nameplate.petName != var2)
            {
                this.nameplate.petName = var2;
                --this.consuming.stackSize;

                if (this.consuming.stackSize <= 0)
                {
                    this.player.inventory.setInventorySlotContents(this.player.inventory.currentItem, (ItemStack)null);
                }
            }
            closeScreen();
        }
        else if (actionevent.getSource() == buttonC)
        {
            closeScreen();
        }
    }

    public boolean doesGuiPauseGame()
    {
        return true;
    }

    public void drawScreen(int var1, int var2, float var3)
    {
        this.drawTexturedModalRect(0, 0, this.width, this.height / 3, 1611665424, -535818224);
        this.drawRect(0, this.height / 3, this.width, this.height / 3 * 2, -535818224);
        this.drawTexturedModalRect(0, this.height / 3 * 2, this.width, this.height, -535818224, 1611665424);
        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
        GL11.glEnable(GL11.GL_COLOR_MATERIAL);
        GL11.glPushMatrix();
        float var4 = 40.0F;

        if (this.owner.height > 2.0F)
        {
            var4 = var4 * 2.0F / this.owner.height;
        }

        float var5 = (float)(this.width / 2);
        float var6 = (float)(this.height / 2 + 20);
        GL11.glTranslatef(var5, var6, 50.0F);
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        GL11.glScalef(-var4, var4, var4);
        GL11.glRotatef(180.0F, 0.0F, 0.0F, 1.0F);
        float var7 = var5 - (float)var1;
        float var8 = var6 - 50.0F - (float)var2;
        float var9 = this.owner.renderYawOffset;
        float var10 = this.owner.rotationYaw;
        float var11 = this.owner.rotationPitch;
        GL11.glRotatef(135.0F, 0.0F, 1.0F, 0.0F);
        RenderHelper.enableStandardItemLighting();
        GL11.glRotatef(-135.0F, 0.0F, 1.0F, 0.0F);
        GL11.glRotatef(-((float)Math.atan((double)(var8 / 40.0F))) * 20.0F, 1.0F, 0.0F, 0.0F);
        this.owner.renderYawOffset = (float)Math.atan((double)(var7 / 40.0F)) * 20.0F;
        this.owner.rotationYaw = (float)Math.atan((double)(var7 / 40.0F)) * 40.0F;
        this.owner.rotationPitch = -((float)Math.atan((double)(var8 / 40.0F))) * 20.0F;
        GL11.glTranslatef(0.0F, this.owner.yOffset, 0.0F);
        RenderManager.instance.playerViewY = 180.0F;
        RenderManager.instance.renderEntityWithPosYaw(this.owner, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F);
        GL13.glMultiTexCoord2f(GL13.GL_TEXTURE1, 240.0F, 240.0F);
        GL11.glPopMatrix();
        RenderHelper.disableStandardItemLighting();
        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
        this.owner.renderYawOffset = var9;
        this.owner.rotationYaw = var10;
        this.owner.rotationPitch = var11;
        //this.input.drawTextBox();
        this.drawString(this.fontRenderer, "Please give a new name", this.width / 2, 50, 16777215);
        super.drawScreen(var1, var2, var3);
    }

    protected void keyTyped(char var1, int var2)
    {
        //this.input.textboxKeyTyped(var1, var2);
    }
}
