package net.minecraft.src;

import org.lwjgl.opengl.GL11;

import net.minecraft.client.Minecraft;

public class RenderNameplate extends RenderEntity
{
    public void doRender(Entity entity, double var2, double var4, double var6, float var8, float var9)
    {
        FontRenderer fontRenderer = this.getFontRendererFromRenderManager();

        if (entity instanceof EntityNameplate)
        {
            EntityNameplate nameplate = (EntityNameplate)entity;

            if (nameplate.entityOwner != null)
            {
                Minecraft minecraft = ModLoader.getMinecraftInstance();
                double renderX = nameplate.posX - minecraft.thePlayer.posX;
                double renderY = nameplate.posY - minecraft.thePlayer.posY + (double)nameplate.entityOwner.height + mod_Nameplate.NameplateHeight;
                double renderZ = nameplate.posZ - minecraft.thePlayer.posZ;
                //System.out.println(String.format("renderX=%f, renderY=%f, renderZ=%f", new Object[] { renderX, renderY, renderZ }));

                double distance = minecraft.thePlayer.getDistance(nameplate.posX, nameplate.posY, nameplate.posZ);
                //System.out.println(String.format("thePlayer.getDistance=%f", new Object[] { distance }));
                if (distance < mod_Nameplate.ShowDistance)
                {
                    GL11.glPushMatrix();
                    GL11.glTranslatef((float)renderX, (float)renderY, (float)renderZ);
                    GL11.glNormal3f(0.0F, 1.0F, 0.0F);
                    GL11.glRotatef(-this.renderManager.playerViewY, 0.0F, 1.0F, 0.0F);

                	/*
                    if (ModLoader.getMinecraftInstance().gameSettings.particleSetting == 2)
                    {
                        GL11.glRotatef(-this.renderManager.playerViewX, 1.0F, 0.0F, 0.0F);
                    }
                    else
                    {
                    	*/
                        GL11.glRotatef(this.renderManager.playerViewX, 1.0F, 0.0F, 0.0F);
                    	/*
                    }
                	*/

                    float var19 = (float)mod_Nameplate.NameplateScale * 0.0166667F;
                    GL11.glScalef(-var19, -var19, var19);
                    GL11.glEnable(GL11.GL_BLEND);
                    GL11.glDisable(GL11.GL_LIGHTING);
                    GL11.glDisable(GL11.GL_DEPTH_TEST);
                    GL11.glDepthMask(false);
                    GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
                    GL11.glDisable(GL11.GL_TEXTURE_2D);
                    double leftPos = (double)fontRenderer.getStringWidth(nameplate.petName) / 2.0D;
                    Tessellator var22 = Tessellator.instance;
                    var22.startDrawingQuads();
                    var22.setColorRGBA_I(mod_Nameplate.NameplateBkgnd, mod_Nameplate.NameplateBkgnd >> 24);
                    var22.addVertex(-leftPos - 1.0D, -1.0D, 0.0D);
                    var22.addVertex(-leftPos - 1.0D, 8.0D, 0.0D);
                    var22.addVertex(leftPos + 1.0D, 8.0D, 0.0D);
                    var22.addVertex(leftPos + 1.0D, -1.0D, 0.0D);
                    var22.draw();
                    GL11.glEnable(GL11.GL_TEXTURE_2D);
                    int bgcolor = (mod_Nameplate.NameplateColor & 16579836) >> 2 | mod_Nameplate.NameplateColor & -16777216;
                    fontRenderer.drawString(nameplate.petName, (int)(-leftPos) + 1, 1, bgcolor);
                    GL11.glEnable(GL11.GL_DEPTH_TEST);
                    GL11.glDepthMask(true);
                    fontRenderer.drawString(nameplate.petName, (int)(-leftPos), 0, mod_Nameplate.NameplateColor);
                    GL11.glEnable(GL11.GL_LIGHTING);
                    GL11.glDisable(GL11.GL_BLEND);
                    GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
                    GL11.glPopMatrix();
                }
            }
        }
    }
}
